#include<iostream.h>	// pour cin et cout
#include<time.h> 		// pour randomize
#include<stdlib.h>     	// pour random et randomize
#include<conio.h>	      // pour le getch()

struct carte {
	char couleur;	// 'c'=coeur, 'k'=carreau, 't'=trefle, 'p'=pique
	int  valeur;	// 1,2, ... nb_cartes_par_couleur
	};

				//pour les piles
typedef carte type_elt;
// inclure votre fichier pile.h

				// pour les files
typedef carte f_elt;
#include "file.h"

/////////////////////////////////////////////////////////////////////
// prototype des fonctions
/////////////////////////////////////////////////////////////////////

						// pour une carte donnee,
						// affiche sa couleur et sa valeur
void affiche_carte(carte une_carte);

						// affiche une par une les cartes du jeu
void affiche_jeu(carte jeu[52]);

						// affiche les cartes d'une main
						// en commencant par le debut
void affiche_main(file main);

						// pour une carte donnee,
						//renvoie une entier donnant sa hauteur
						// pour pouvoir comparer 2 cartes, on a :
						// '2' < '3' < ... < '9' < 'X' < 'V'
						//				< 'D' < 'R' < '1'
int hauteur(carte une_carte);

						// initialise un vecteur de 52 cartes
						// avec 4 couleur x 13 valeur
void construire_jeu(carte jeu[]);

						// melange aleatoirement un jeu de 52 cartes
void melanger(carte jeu[]);

						// distribue une par une et
						// alternativement les cartes du jeu
						// a main_1 et a main_2
void distribuer(carte jeu[], file & main_1, file & main_2);

						// affiche une phase de jeu, c-a-d :
						// nb de cartes ds la main du joueur 1,
						// carte sur le sommet du tas du joueur 1,
						// nb de cartes dans les tas,
						// carte sur le sommet du tas du joueur 2,
						// nb de cartes ds la main du joueur 2,
void affiche_phase_jeu(int nb_main_1, carte sommet_tas_1, int nb_tas,
				carte sommet_tas_2, int nb_main_2);


//////////////////////// constantes globales ///////////////////////////

const int nb_couleurs = 4;  		// forcement
const int nb_cartes_par_couleur = 13;
const int nb_cartes_jeu = nb_couleurs * nb_cartes_par_couleur;

///////////////////// programme principal /////////////////////////////////

void main (void){
}

////////////////////// definition des fonctions /////////////////////////

///////////////////////////// affiche_carte /////////////////////////////
// affiche la couleur et la valeur d'une carte

void affiche_carte(carte une_carte)
{
cout << " " ;

if ((2 <= une_carte.valeur) && (une_carte.valeur <= 9))
	cout << "    " << une_carte.valeur;
else
	switch (une_carte.valeur)
	{
	case 1 : cout << "   As"; break;
	case 10: cout << "   10"; break;
	case 11: cout << "Valet"; break;
	case 12: cout << " Dame"; break;
	case 13: cout << "  Roi"; break;
	}
cout << " de ";
switch (une_carte.couleur)
	{
	case 'c': cout << "coeur   ";
		  break;
	case 'k': cout << "carreau ";
		  break;
	case 't': cout << "trefle  ";
		  break;
	case 'p': cout << "pique   ";
		  break;
	}
}

////////////////////////////// hauteur ////////////////////////////////
// pour une carte donnee, renvoie une entier correspondant a sa hauteur
// afin de pouvoir comparer deux cartes, on a :
// 2 < 3 < ... < 9 < 10 < valet < dame < roi < as

int hauteur(carte une_carte){
if (une_carte.valeur == 1)
	return 14;
else
	return(une_carte.valeur);
}

/////////////////////////////// affiche_jeu ////////////////////////////
// affiche une par une les cartes du jeu

void affiche_jeu(carte jeu[])
{
int i;
cout << endl << endl;
for(i=0; i<nb_cartes_jeu; i++)
	{
	affiche_carte(jeu[i]);
	cout << "   ";
	if (!((i+1)%3)) cout << endl;
	}
cout << endl << endl;
}

///////////////// affiche les cartes d'une main /////////////////////////
void affiche_main(file main)
{
f_cellule * aux;
int cpt=1;
aux=main.first;
cout << endl;
while (aux!=NULL)
	{
	affiche_carte(aux->info);
	aux=aux->suiv;
	if(!(cpt%3)) cout << endl;
	cpt++;
	}
cout << endl;
}

/////////////////////////// construire_jeu /////////////////////////////
// initialise un vecteur de cartes avec nb_couleurs couleurs
// et nb_cartes_par_couleur valeurs

void construire_jeu(carte jeu[])
{
int i,j,nbc;
cout << "construction du jeu";
							// les couleurs
nbc = nb_cartes_par_couleur;
for(i=0;     i < nbc; i++) jeu[i].couleur='p';
for(i=nbc;   i < 2*nbc; i++) jeu[i].couleur='c';
for(i=2*nbc; i < 3*nbc; i++) jeu[i].couleur='k';
for(i=3*nbc; i < 4*nbc; i++) jeu[i].couleur='t';

							// les valeurs
for(i=0; i<nb_couleurs; i++)
	{
	for(j=0; j < nb_cartes_par_couleur; j++)
		jeu[(i*nbc)+j].valeur = j+1;
	}
}

///////////////////////////// melanger /////////////////////////////////
// melange aleatoirement un jeu de 52 cartes

void melanger(carte jeu[])
{
int i,rd;
carte aux;
randomize();
cout << "melange du jeu";
for(i=0;i<nb_cartes_jeu;i++)		// on parcourt le jeu, pour chaque indice
	{			// on echange la carte situee a cet indice
	rd=random(nb_cartes_jeu);		// avec une carte dont l'indice est obtenu
	aux=jeu[i];		// aleatoirement
	jeu[i]=jeu[rd];
	jeu[rd]=aux;
	}
}

////////////////////////////////// distribuer ///////////////////////////
// distribue une par une et alternativement les cartes d'un jeu
// a main_1 et a main_2

void distribuer(carte jeu[], file & main_1, file & main_2)
{
int i;
cout << "distribution du jeu"<<endl;
for(i=0; i<nb_cartes_jeu; i=i+2)
	{
	enfiler(jeu[i],main_1);
	enfiler(jeu[i+1],main_2);
	}
}

///////////////////////////////// affiche_phase_jeu ///////////////////////
// affiche les donnees concernant chaque phase de jeu, c-a-d :
//    le nombre de cartes dans la main du joueur 1,
// 	la carte sur le sommet du tas du joueur 1,
// 	le nombre de cartes dans les tas,
// 	la carte sur le sommet du tas du joueur 2,
// 	le nombre de cartes dans la main du joueur 2,

void affiche_phase_jeu(int nb_main_1, carte sommet_tas_1, int nb_tas,
				carte sommet_tas_2, int nb_main_2)
{
cout<< nb_main_1 << "      ";
affiche_carte(sommet_tas_1);
cout <<"      "<< nb_tas<<"      ";
affiche_carte(sommet_tas_2);
cout<< "      "<<nb_main_2 << endl;
}




